Introduction

This is our page of ideas for the [Google Summer of Code 2010](http://socghop.appspot.com/). If you are a student, you can participate by developing one of the projects we describe here (or propose an idea of your own!), and get paid through a stipend by Google. Read the [Google Summer of Code 2010 FAQ](http://socghop.appspot.com/document/show/gsoc_program/google/gsoc2010/faqs) for more details about the program.
Important dates

    March 08 to March 12 - Mentor organization application period
    March 18 - Announcement of accepted mentor organizations.
    March 29 to April 09 - Student application period
    April 26 - Announcement of accepted students
    May 24 to August 16 - Coding period

See the [authorative timeline](http://socghop.appspot.com/document/show/gsoc_program/google/gsoc2010/timeline) for more details.
Information for students

The Google Summer of Code is a program for students in most countries. You will participate by writing code for a free software project. Students who finish their work satisfactorily will get a stipend of 4500 US Dollars.

Do this if you want to participate:

    Start by reading the [Google Summer of Code FAQ](http://socghop.appspot.com/document/show/gsoc_program/google/gsoc2010/faqs)
    See which of the Ideas below you find interesting or come up with your own idea.
    Get in contact with the community
    Submit your proposal on the Google Summer of Code website

Your proposal should include this information:

    Give a detailed idea of what you want to accomplish in your project. Don't just quote what the project's abstract says! Think of how you will actually implement it, and describe that.
    Give a general idea of your skills. If you have participated in a free software project before, say so and if possible point to your contributions.
    Give a rough timeline for your work, with milestones. For example: "week 1, get the code to build and start familiarizing myself with it. Week 2, implement the first refactoring patch. Week 3, try such and such thing."

Basically, let us know why you are the perfect person to implement the project you picked :)
Ideas

This is a list of ideas for projects which could be done as part of the Google Summer of Code program. If you have an idea and want to mentor it, please add it to the list.

If you are a student and want to work on an idea, submit a proposal. You are not limited to the ideas listed here. If you have an own idea or want to approach an idea in a completely different way, feel free to submit this as proposal as well. Sometimes these are the best projects. Creativity and initiative are highly appreciated.
Path Tool Enhancements

    Required knowledge: SVG, JS, CSS, jQuery

    Skill level: Advanced
    Mentor: TBD
    Student: TBD
    Description:

    add/delete arbitrary points on a path
    join points/paths
    continue from endpoint
    click-drag makes curve/bezier point instead of corner point
    simplify path algorithms
    drag from lines as well as points

Objects on Path

    Required knowledge: SVG, JS, CSS, jQuery
    Skill level: Experienced
    Mentor: TBD
    Student: TBD
    Description:

        Multiple duplicate object/instances along a path with either evenly spaced (user configurable) or at each point on the path.

Object along Path Enhancements

    Required knowledge: SVG, JS, CSS, jQuery
    Skill level: Advanced
    Mentor: TBD
    Student: TBD
    Description:

        Object A is stretched along a path B.

Union/Intersection/Difference for shapes

    Required knowledge: SVG, JS, CSS, jQuery
    Skill level: Advanced
    Mentor: TBD
    Student: TBD
    Description:

        2 or more overlapping objects when selected are either a) Combined to make one object from the outline of both or b) Like a Venn diagram we take only the shared intersecting area or c) Take the area of the two objects that are not intersecting

Rulers/Guides/Units Enhancements

    Required knowledge: SVG, JS, CSS, jQuery
    Skill level: Experienced
    Mentor: TBD
    Student: TBD
    Description:

        Add rules and guides with configurable units

Bring forward/Send backward incremental

    Required knowledge: SVG, JS, CSS, jQuery
    Skill level: Experienced
    Mentor: TBD
    Student: TBD
    Description:

        Currently moving an object all the way forward or backward is the only option, but adding the functionality to move forward or backward one object at a time is much better.

Layer Drag and Drop Enhancement

    Required knowledge: JS, CSS, jQuery
    Skill level: Novice
    Mentor: TBD
    Student: TBD
    Description:

        Enable Users to move the layers around by dragging them to change the order

History Interface in Sidebar

    Required knowledge: JS, CSS, jQuery
    Skill level: Novice
    Mentor: TBD
    Student: TBD
    Description:

        A visual representation of the undo/redo stack with the ability to go back n number of steps at will.

Pattern Fills

    Required knowledge: SVG, JS, CSS, jQuery
    Skill level: Experienced
    Mentor: TBD
    Student: TBD
    Description:

        Use a pattern to define a fill pattern

Documentation Enhancements

    Required knowledge: Must possess technical writing skills and experience with graphics applications is a big plus.
    Skill level: Novice
    Mentor: TBD
    Student: TBD
    Description:

        User Docs and Guides
        API/Extensions

{IDEA_TITLE_TO_BE_REPLACED}

Required knowledge: What does the prospective student need to know before attempting this idea?.

Skill level: How difficult would this idea be to implement if the student has the required knowledge

Mentor: Your name and contact will go here.

Student: Your name and contact will go here.

Description of idea goes here, try and be as detailed as possible.

Links

http://socghop.appspot.com/document/show/gsoc_program/google/gsoc2010/faqs'>Google Summer of Code FAQ
http://code.google.com/soc/'>Google Summer of Code main page
