# Contributing

1. Prefix every change in the commit (and change log) with one of the
  following types (and sort in both places into this order):
  - `Security fix: `
  - `Known regression: `
  - `Breaking change: `
  - `Deprecated:`
  - `Compatibility fix: `
  - `Fix: `
  - `Fix (<component>): ` - Component may be an extension, locale, etc.
  - `Forward compatibility enhancement: `
  - `Enhancement: `
  - `Optimization: ` - Performance enhancements
  - `Localization:`
  - `Docs: `
  - `Update: ` - e.g., if updating a bundled library or updating code per a
    dependency's updated new API
  - `Refactoring: `
  - `Linting (<type>):` - Linting by type, e.g., "ESLint"
  - `Testing (<UI|Unit>):`
  - `Build: `
  - `npm` - Updates to dependencies, npm version, etc.
1. See [`Testing.md`](./Testing.md) for other information helpful for contributing.
